Index: vendors/IOIPSL/current/src/histcom.f90
===================================================================
--- vendors/IOIPSL/current/src/histcom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/histcom.f90	(revision 1991)
@@ -1288,30 +1155,28 @@
       CALL ipslerr (3,"histdef",str70,str71,str72)
     ENDIF
-    var_zaxid(pfileid,iv) = pzid
+    W_F(idf)%W_V(iv)%z_axid = pzid
   ELSE
-    var_zaxid(pfileid,iv) = -99
-  ENDIF
-!-
-! 3.0 Determine the position of the variable in the buffer
-!     If it is instantaneous output then we do not use the buffer
-!-
-  IF (l_dbg) WRITE(*,*) "histdef : 3.0"
-!-
-! 3.1 We get the size of the arrays histwrite will get and check
-!     that they fit into the tmp_buffer
-!-
-  buff_sz = zsize(pfileid,iv,1)*zsize(pfileid,iv,2)*zsize(pfileid,iv,3)
-!-
-! 3.2 move the pointer of the buffer array for operation
-!     which need bufferisation
-!-
-  IF (     (TRIM(tmp_topp) /= "inst") &
- &    .AND.(TRIM(tmp_topp) /= "once") &
- &    .AND.(TRIM(tmp_topp) /= "never") )THEN
-    point(pfileid,iv) = buff_pos+1
-    buff_pos = buff_pos+buff_sz
+    W_F(idf)%W_V(iv)%z_axid = -99
+  ENDIF
+!-
+! 3.0 We get the size of the arrays histwrite will get
+!     and eventually allocate the time_buffer
+!-
+  IF (l_dbg) THEN
+    WRITE(*,*) "histdef : 3.0"
+  ENDIF
+!-
+  buff_sz = W_F(idf)%W_V(iv)%zsize(1) &
+ &         *W_F(idf)%W_V(iv)%zsize(2) &
+ &         *W_F(idf)%W_V(iv)%zsize(3)
+!-
+  IF (     (TRIM(W_F(idf)%W_V(iv)%topp) /= "inst") &
+ &    .AND.(TRIM(W_F(idf)%W_V(iv)%topp) /= "once") &
+ &    .AND.(TRIM(W_F(idf)%W_V(iv)%topp) /= "never") )THEN
+    ALLOCATE(W_F(idf)%W_V(iv)%t_bf(buff_sz))
+    W_F(idf)%W_V(iv)%t_bf(:) = 0.
     IF (l_dbg) THEN
-      WRITE(*,*) "histdef : 3.2 bufpos for iv = ",iv, &
- &               " pfileid = ",pfileid," is = ",point(pfileid,iv)
+      WRITE(*,*) "histdef : 3.0 allocating time_buffer for", &
+ &      " idf = ",idf," iv = ",iv," size = ",buff_sz
     ENDIF
   ENDIF
@@ -1324,6 +1189,6 @@
   IF (l_dbg) WRITE(*,*) "histdef : 4.0"
 !-
-  freq_opp(pfileid,iv) = pfreq_opp
-  freq_wrt(pfileid,iv) = pfreq_wrt
+  W_F(idf)%W_V(iv)%freq_opp = pfreq_opp
+  W_F(idf)%W_V(iv)%freq_wrt = pfreq_wrt
 !-
   CALL ioget_calendar(un_an,un_jour)
@@ -1343,5 +1208,5 @@
 ! 4.1 Frequency of operations and output should be larger than deltat !
 !-
-  IF (test_fopp < deltat(pfileid)) THEN
+  IF (test_fopp < W_F(idf)%deltat) THEN
     str70 = 'Frequency of operations should be larger than deltat'
     WRITE(str71,'("It is not the case for variable ",a," :",F10.4)') &
@@ -1351,8 +1216,8 @@
     CALL ipslerr (2,"histdef",str70,str71,str72)
 !-
-    freq_opp(pfileid,iv) = deltat(pfileid)
-  ENDIF
-!-
-  IF (test_fwrt < deltat(pfileid)) THEN
+    W_F(idf)%W_V(iv)%freq_opp = W_F(idf)%deltat
+  ENDIF
+!-
+  IF (test_fwrt < W_F(idf)%deltat) THEN
     str70 = 'Frequency of output should be larger than deltat'
     WRITE(str71,'("It is not the case for variable ",a," :",F10.4)') &
@@ -1362,5 +1227,5 @@
     CALL ipslerr (2,"histdef",str70,str71,str72)
 !-
-    freq_wrt(pfileid,iv) = deltat(pfileid)
+    W_F(idf)%W_V(iv)%freq_wrt = W_F(idf)%deltat
   ENDIF
 !-
@@ -1368,5 +1233,5 @@
 !     its compaticility with the choice of frequencies
 !-
-  IF (TRIM(tmp_topp) == "inst") THEN
+  IF (TRIM(W_F(idf)%W_V(iv)%topp) == "inst") THEN
     IF (test_fopp /= test_fwrt) THEN
       str70 = 'For instantaneous output the frequency '// &
@@ -1378,15 +1243,15 @@
       CALL ipslerr (2,"histdef",str70,str71,str72)
       IF (test_fopp < test_fwrt) THEN
-        freq_opp(pfileid,iv) = pfreq_opp
-        freq_wrt(pfileid,iv) = pfreq_opp
+        W_F(idf)%W_V(iv)%freq_opp = pfreq_opp
+        W_F(idf)%W_V(iv)%freq_wrt = pfreq_opp
       ELSE
-        freq_opp(pfileid,iv) = pfreq_wrt
-        freq_wrt(pfileid,iv) = pfreq_wrt
+        W_F(idf)%W_V(iv)%freq_opp = pfreq_wrt
+        W_F(idf)%W_V(iv)%freq_wrt = pfreq_wrt
       ENDIF
     ENDIF
-  ELSE IF (INDEX(ex_topps,TRIM(tmp_topp)) > 0) THEN
+  ELSE IF (INDEX(ex_topps,TRIM(W_F(idf)%W_V(iv)%topp)) > 0) THEN
     IF (test_fopp > test_fwrt) THEN
       str70 = 'For averages the frequency of operations '// &
-&             'should be smaller or equal'
+ &            'should be smaller or equal'
       WRITE(str71, &
  &     '("to that of output. It is not the case for variable ",a)') &
@@ -1394,11 +1259,12 @@
       str72 = 'PATCH : The output frequency is used for both'
       CALL ipslerr (2,"histdef",str70,str71,str72)
-      freq_opp(pfileid,iv) = pfreq_wrt
+      W_F(idf)%W_V(iv)%freq_opp = pfreq_wrt
     ENDIF
   ELSE
-    WRITE (str70,'("Operation on variable ",a," is unknown")') &
-&    TRIM(tmp_name)
-    WRITE (str71,'("operation requested is :",a)') tmp_topp
-    WRITE (str72,'("File ID :",I3)') pfileid
+    WRITE (str70,'("Operation on variable ",A," is unknown")') &
+ &   TRIM(tmp_name)
+    WRITE (str71,'("operation requested is :",A)') &
+ &   W_F(idf)%W_V(iv)%topp
+    WRITE (str72,'("File ID :",I3)') idf
     CALL ipslerr (3,"histdef",str70,str71,str72)
   ENDIF
@@ -1408,25 +1274,25 @@
   IF (l_dbg) WRITE(*,*) "histdef : 5.0"
 !-
-  hist_wrt_rng(pfileid,iv) = (PRESENT(var_range))
-  IF (hist_wrt_rng(pfileid,iv)) THEN
-    hist_calc_rng(pfileid,iv) = (var_range(1) > var_range(2))
-    IF (hist_calc_rng(pfileid,iv)) THEN
-      hist_minmax(pfileid,iv,1:2) = &
+  W_F(idf)%W_V(iv)%hist_wrt_rng = (PRESENT(var_range))
+  IF (W_F(idf)%W_V(iv)%hist_wrt_rng) THEN
+    W_F(idf)%W_V(iv)%hist_calc_rng = (var_range(1) > var_range(2))
+    IF (W_F(idf)%W_V(iv)%hist_calc_rng) THEN
+      W_F(idf)%W_V(iv)%hist_minmax(1:2) = &
  &      (/ ABS(missing_val),-ABS(missing_val) /)
     ELSE
-      hist_minmax(pfileid,iv,1:2) = var_range(1:2)
-    ENDIF
-  ENDIF
-!-
-! - freq_opp(pfileid,iv)/2./deltat(pfileid)
-  last_opp(pfileid,iv) = itau0(pfileid)
-! - freq_wrt(pfileid,iv)/2./deltat(pfileid)
-  last_wrt(pfileid,iv) = itau0(pfileid)
-! - freq_opp(pfileid,iv)/2./deltat(pfileid)
-  last_opp_chk(pfileid,iv) = itau0(pfileid)
-! - freq_wrt(pfileid,iv)/2./deltat(pfileid)
-  last_wrt_chk(pfileid,iv) = itau0(pfileid)
-  nb_opp(pfileid,iv) = 0
-  nb_wrt(pfileid,iv) = 0
+      W_F(idf)%W_V(iv)%hist_minmax(1:2) = var_range(1:2)
+    ENDIF
+  ENDIF
+!-
+! - freq_opp(idf,iv)/2./deltat(idf)
+  W_F(idf)%W_V(iv)%last_opp = W_F(idf)%itau0
+! - freq_wrt(idf,iv)/2./deltat(idf)
+  W_F(idf)%W_V(iv)%last_wrt = W_F(idf)%itau0
+! - freq_opp(idf,iv)/2./deltat(idf)
+  W_F(idf)%W_V(iv)%last_opp_chk = W_F(idf)%itau0
+! - freq_wrt(idf,iv)/2./deltat(idf)
+  W_F(idf)%W_V(iv)%last_wrt_chk = W_F(idf)%itau0
+  W_F(idf)%W_V(iv)%nb_opp = 0
+  W_F(idf)%W_V(iv)%nb_wrt = 0
 !-
 ! 6.0 Get the time axis for this variable
@@ -1434,30 +1300,38 @@
   IF (l_dbg) WRITE(*,*) "histdef : 6.0"
 !-
-  IF (freq_wrt(pfileid,iv) > 0) THEN
-    WRITE(str10,'(I8.8)') INT(freq_wrt(pfileid,iv))
-    str40 = TRIM(tmp_topp)//"_"//TRIM(str10)
+! No time axis for once, l_max, l_min or never operation
+!-
+  IF (     (TRIM(W_F(idf)%W_V(iv)%topp) /= 'once')  &
+ &    .AND.(TRIM(W_F(idf)%W_V(iv)%topp) /= 'never') &
+ &    .AND.(TRIM(W_F(idf)%W_V(iv)%topp) /= 'l_max') &
+ &    .AND.(TRIM(W_F(idf)%W_V(iv)%topp) /= 'l_min') ) THEN
+    IF (TRIM(W_F(idf)%W_V(iv)%topp) == 'inst') THEN
+      str10 = 't_inst_'
+    ELSE
+      str10 = 't_op_'
+    ENDIF
+    IF (W_F(idf)%W_V(iv)%freq_wrt > 0) THEN
+      WRITE (UNIT=str40,FMT='(A,I8.8)') &
+&      TRIM(str10),INT(W_F(idf)%W_V(iv)%freq_wrt)
+    ELSE
+      WRITE (UNIT=str40,FMT='(A,I2.2,"month")') &
+&      TRIM(str10),ABS(INT(W_F(idf)%W_V(iv)%freq_wrt))
+    ENDIF
+    CALL find_str (W_F(idf)%W_V(1:W_F(idf)%n_tax)%tax_name,str40,pos)
+    IF (pos < 0) THEN
+      W_F(idf)%n_tax = W_F(idf)%n_tax+1
+      W_F(idf)%W_V(iv)%l_bnd = &
+ &      (TRIM(W_F(idf)%W_V(iv)%topp) /= 'inst')
+      W_F(idf)%W_V(W_F(idf)%n_tax)%tax_name = str40
+      W_F(idf)%W_V(W_F(idf)%n_tax)%tax_last = 0
+      W_F(idf)%W_V(iv)%t_axid = W_F(idf)%n_tax
+    ELSE
+      W_F(idf)%W_V(iv)%t_axid = pos
+    ENDIF
   ELSE
-    WRITE(str10,'(I2.2,"month")') ABS(INT(freq_wrt(pfileid,iv)))
-    str40 = TRIM(tmp_topp)//"_"//TRIM(str10)
-  ENDIF
-  CALL find_str (tax_name(pfileid,1:nb_tax(pfileid)),str40,pos)
-!-
-! No time axis for once, l_max, l_min or never operation
-!-
-  IF (     (TRIM(tmp_topp) /= 'once')  &
- &    .AND.(TRIM(tmp_topp) /= 'never') &
- &    .AND.(TRIM(tmp_topp) /= 'l_max') &
- &    .AND.(TRIM(tmp_topp) /= 'l_min') ) THEN
-    IF (pos < 0) THEN
-      nb_tax(pfileid) = nb_tax(pfileid)+1
-      tax_name(pfileid,nb_tax(pfileid)) = str40
-      tax_last(pfileid,nb_tax(pfileid)) = 0
-      var_axid(pfileid,iv) = nb_tax(pfileid)
-    ELSE
-      var_axid(pfileid,iv) = pos
-    ENDIF
-  ELSE
-    IF (l_dbg)   WRITE(*,*) "histdef : 7.0 ",TRIM(tmp_topp),'----'
-    var_axid(pfileid,iv) = -99
+    IF (l_dbg) THEN
+      WRITE(*,*) "histdef : 7.0 ",TRIM(W_F(idf)%W_V(iv)%topp),'----'
+    ENDIF
+    W_F(idf)%W_V(iv)%t_axid = -99
   ENDIF
 !-
@@ -1465,13 +1339,13 @@
 !     for never or once operation
 !-
-  IF (    (TRIM(tmp_topp) == 'once')  &
- &    .OR.(TRIM(tmp_topp) == 'never') ) THEN
-    freq_opp(pfileid,iv) = 0.
-    freq_wrt(pfileid,iv) = 0.
+  IF (    (TRIM(W_F(idf)%W_V(iv)%topp) == 'once')  &
+ &    .OR.(TRIM(W_F(idf)%W_V(iv)%topp) == 'never') ) THEN
+    W_F(idf)%W_V(iv)%freq_opp = 0.
+    W_F(idf)%W_V(iv)%freq_wrt = 0.
   ENDIF
 !---------------------
 END SUBROUTINE histdef
 !===
-SUBROUTINE histend (pfileid)
+SUBROUTINE histend (idf)
 !---------------------------------------------------------------------
 !- This subroutine end the decalaration of variables and sets the
@@ -1480,5 +1354,5 @@
 !- INPUT
 !-
-!- pfileid : ID of the file to be worked on
+!- idf : ID of the file to be worked on
 !-
 !- VERSION
@@ -1487,7 +1361,7 @@
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid
-!-
-  INTEGER :: ncid,ncvarid,iret,ndim,iv,itx,ziv,itax,dim_cnt
+  INTEGER,INTENT(IN) :: idf
+!-
+  INTEGER :: nfid,nvid,iret,ndim,iv,itx,ziv,itax,dim_cnt
   INTEGER,DIMENSION(4) :: dims
   INTEGER :: year,month,day,hours,minutes
@@ -1495,4 +1369,5 @@
   REAL :: rtime0
   CHARACTER(LEN=30) :: str30
+  CHARACTER(LEN=35) :: str35
   CHARACTER(LEN=120) :: assoc
   CHARACTER(LEN=70) :: str70
@@ -1501,31 +1376,46 @@
  &     'JUL','AUG','SEP','OCT','NOV','DEC' /)
   CHARACTER(LEN=7) :: tmp_opp
+  LOGICAL :: l_b
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
   CALL ipsldbg (old_status=l_dbg)
 !-
-  ncid = ncdf_ids(pfileid)
+  nfid = W_F(idf)%ncfid
 !-
 ! 1.0 Create the time axes
 !-
   IF (l_dbg) WRITE(*,*) "histend : 1.0"
-!---
-  iret = NF90_DEF_DIM (ncid,'time_counter',NF90_UNLIMITED,tid(pfileid))
-!-
-! 1.1 Define all the time axes needed for this file
-!-
-  DO itx=1,nb_tax(pfileid)
-    dims(1) = tid(pfileid)
-    IF (nb_tax(pfileid) > 1) THEN
-      str30 = "t_"//tax_name(pfileid,itx)
+!-
+! 1.1 Define the time dimensions needed for this file
+!-
+  iret = NF90_DEF_DIM (nfid,'time_counter', &
+ &                     NF90_UNLIMITED,W_F(idf)%tid)
+  DO iv=1,W_F(idf)%n_var
+    IF (W_F(idf)%W_V(iv)%l_bnd) THEN
+      iret = NF90_DEF_DIM (nfid,'tbnds',2,W_F(idf)%bid)
+      EXIT
+    ENDIF
+  ENDDO
+!-
+! 1.2 Define all the time axes needed for this file
+!-
+  DO itx=1,W_F(idf)%n_tax
+    dims(1) = W_F(idf)%tid
+    l_b = (INDEX(W_F(idf)%W_V(itx)%tax_name,"t_op_") == 1)
+    IF (itx > 1) THEN
+      str30 = W_F(idf)%W_V(itx)%tax_name
     ELSE
       str30 = "time_counter"
     ENDIF
-    iret = NF90_DEF_VAR (ncid,str30,NF90_DOUBLE, &
- &                       dims(1),tdimid(pfileid,itx))
-    IF (nb_tax(pfileid) <= 1) THEN
-      iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx),'axis',"T")
-    ENDIF
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx),'standard_name',"time")
+    IF (l_b) THEN
+      str35 = TRIM(str30)//'_bnds'
+    ENDIF
+    iret = NF90_DEF_VAR (nfid,TRIM(str30),NF90_REAL8, &
+ &          dims(1),W_F(idf)%W_V(itx)%tdimid)
+    IF (itx <= 1) THEN
+      iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid,'axis',"T")
+    ENDIF
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &          'standard_name',"time")
 !---
 !   To transform the current itau into a real date and take it
@@ -1535,6 +1425,6 @@
 !   if there is a ioconf routine to control it.
 !---
-!-- rtime0 = itau2date(itau0(pfileid),date0(pfileid),deltat(pfileid))
-    rtime0 = date0(pfileid)
+!-- rtime0 = itau2date(itau0(idf),date0(idf),deltat(idf))
+    rtime0 = W_F(idf)%date0
 !-
     CALL ju2ymds(rtime0,year,month,day,sec)
@@ -1553,20 +1443,30 @@
  &   FMT='(A,I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":",I2.2)') &
  &    'seconds since ',year,month,day,hours,minutes,INT(sec)
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx),'units',TRIM(str70))
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &           'units',TRIM(str70))
 !-
     CALL ioget_calendar (str30)
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx), &
- &                       'calendar',TRIM(str30))
-!-
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx),'title','Time')
-!-
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx), &
- &                       'long_name','Time axis')
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &           'calendar',TRIM(str30))
+!-
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &           'title','Time')
+!-
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &           'long_name','Time axis')
 !-
     WRITE (UNIT=str70, &
  &   FMT='(" ",I4.4,"-",A3,"-",I2.2," ",I2.2,":",I2.2,":",I2.2)') &
  &    year,cal(month),day,hours,minutes,INT(sec)
-    iret = NF90_PUT_ATT (ncid,tdimid(pfileid,itx), &
- &                       'time_origin',TRIM(str70))
+    iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &           'time_origin',TRIM(str70))
+!---
+    IF (l_b) THEN
+      iret = NF90_PUT_ATT (nfid,W_F(idf)%W_V(itx)%tdimid, &
+ &             'bounds',TRIM(str35))
+      dims(1:2) = (/ W_F(idf)%bid,W_F(idf)%tid /)
+      iret = NF90_DEF_VAR (nfid,TRIM(str35),NF90_REAL8, &
+ &            dims(1:2),W_F(idf)%W_V(itx)%tbndid)
+    ENDIF
   ENDDO
 !-
@@ -1575,18 +1475,18 @@
   IF (l_dbg) WRITE(*,*) "histend : 2.0"
 !-
-  DO iv=1,nb_var(pfileid)
-!---
-    itax = var_axid(pfileid,iv)
-!---
-    IF (regular(pfileid) ) THEN
-      dims(1:2) = (/ xid(pfileid),yid(pfileid) /)
+  DO iv=1,W_F(idf)%n_var
+!---
+    itax = W_F(idf)%W_V(iv)%t_axid
+!---
+    IF (W_F(idf)%regular) THEN
+      dims(1:2) = (/ W_F(idf)%xid,W_F(idf)%yid /)
       dim_cnt = 2
     ELSE
-      dims(1) = xid(pfileid)
+      dims(1) = W_F(idf)%xid
       dim_cnt = 1
     ENDIF
 !---
-    tmp_opp = topp(pfileid,iv)
-    ziv = var_zaxid(pfileid,iv)
+    tmp_opp = W_F(idf)%W_V(iv)%topp
+    ziv = W_F(idf)%W_V(iv)%z_axid
 !---
 !   2.1 dimension of field
@@ -1598,8 +1498,9 @@
         IF (ziv == -99) THEN
           ndim = dim_cnt+1
-          dims(dim_cnt+1:dim_cnt+2) = (/ tid(pfileid),0 /)
+          dims(dim_cnt+1:dim_cnt+2) = (/ W_F(idf)%tid,0 /)
         ELSE
           ndim = dim_cnt+2
-          dims(dim_cnt+1:dim_cnt+2) = (/zax_ids(pfileid,ziv),tid(pfileid)/)
+          dims(dim_cnt+1:dim_cnt+2) = &
+ &         (/ W_F(idf)%zax_ids(ziv),W_F(idf)%tid /)
         ENDIF
       ELSE
@@ -1609,32 +1510,42 @@
         ELSE
           ndim = dim_cnt+1
-          dims(dim_cnt+1:dim_cnt+2) = (/ zax_ids(pfileid,ziv),0 /)
+          dims(dim_cnt+1:dim_cnt+2) = (/ W_F(idf)%zax_ids(ziv),0 /)
         ENDIF
       ENDIF
 !-
-      iret = NF90_DEF_VAR (ncid,TRIM(name(pfileid,iv)),NF90_FLOAT, &
- &                         dims(1:ABS(ndim)),ncvarid)
-!-
-      ncvar_ids(pfileid,iv) = ncvarid
-!-
-      IF (LEN_TRIM(unit_name(pfileid,iv)) > 0) THEN
-        iret = NF90_PUT_ATT (ncid,ncvarid,'units', &
- &                           TRIM(unit_name(pfileid,iv)))
+      iret = NF90_DEF_VAR (nfid,TRIM(W_F(idf)%W_V(iv)%v_name), &
+ &             W_F(idf)%W_V(iv)%v_typ,dims(1:ABS(ndim)),nvid)
+!-
+      W_F(idf)%W_V(iv)%ncvid = nvid
+!-
+      IF (LEN_TRIM(W_F(idf)%W_V(iv)%unit_name) > 0) THEN
+        iret = NF90_PUT_ATT (nfid,nvid,'units', &
+ &                           TRIM(W_F(idf)%W_V(iv)%unit_name))
       ENDIF
-      iret = NF90_PUT_ATT (ncid,ncvarid,'standard_name', &
- &                         TRIM(title(pfileid,iv)))
-!-
-      iret = NF90_PUT_ATT (ncid,ncvarid,'_FillValue', &
- &                         REAL(missing_val,KIND=4))
-      IF (hist_wrt_rng(pfileid,iv)) THEN
-        iret = NF90_PUT_ATT (ncid,ncvarid,'valid_min', &
- &                           REAL(hist_minmax(pfileid,iv,1),KIND=4))
-        iret = NF90_PUT_ATT (ncid,ncvarid,'valid_max', &
- &                           REAL(hist_minmax(pfileid,iv,2),KIND=4))
+      iret = NF90_PUT_ATT (nfid,nvid,'standard_name', &
+ &                         TRIM(W_F(idf)%W_V(iv)%std_name))
+!-
+      IF (W_F(idf)%W_V(iv)%v_typ == hist_r8) THEN
+        iret = NF90_PUT_ATT (nfid,nvid,'_FillValue',NF90_FILL_REAL8)
+      ELSE
+        iret = NF90_PUT_ATT (nfid,nvid,'_FillValue',NF90_FILL_REAL4)
       ENDIF
-      iret = NF90_PUT_ATT (ncid,ncvarid,'long_name', &
- &                         TRIM(title(pfileid,iv)))
-      iret = NF90_PUT_ATT (ncid,ncvarid,'online_operation', &
- &                         TRIM(fullop(pfileid,iv)))
+      IF (W_F(idf)%W_V(iv)%hist_wrt_rng) THEN
+        IF (W_F(idf)%W_V(iv)%v_typ == hist_r8) THEN
+          iret = NF90_PUT_ATT (nfid,nvid,'valid_min', &
+ &                 REAL(W_F(idf)%W_V(iv)%hist_minmax(1),KIND=8))
+          iret = NF90_PUT_ATT (nfid,nvid,'valid_max', &
+ &                 REAL(W_F(idf)%W_V(iv)%hist_minmax(2),KIND=8))
+        ELSE
+          iret = NF90_PUT_ATT (nfid,nvid,'valid_min', &
+ &                 REAL(W_F(idf)%W_V(iv)%hist_minmax(1),KIND=4))
+          iret = NF90_PUT_ATT (nfid,nvid,'valid_max', &
+ &                 REAL(W_F(idf)%W_V(iv)%hist_minmax(2),KIND=4))
+        ENDIF
+      ENDIF
+      iret = NF90_PUT_ATT (nfid,nvid,'long_name', &
+ &                         TRIM(W_F(idf)%W_V(iv)%title))
+      iret = NF90_PUT_ATT (nfid,nvid,'online_operation', &
+ &                         TRIM(W_F(idf)%W_V(iv)%fullop))
 !-
       SELECT CASE(ndim)
@@ -1646,16 +1557,16 @@
       END SELECT
 !-
-      assoc=TRIM(hax_name(pfileid,var_haxid(pfileid,iv),2))  &
- &   //' '//TRIM(hax_name(pfileid,var_haxid(pfileid,iv),1))
-!-
-      ziv = var_zaxid(pfileid,iv)
+      assoc=TRIM(W_F(idf)%hax_name(W_F(idf)%W_V(iv)%h_axid,2)) &
+ &   //' '//TRIM(W_F(idf)%hax_name(W_F(idf)%W_V(iv)%h_axid,1))
+!-
+      ziv = W_F(idf)%W_V(iv)%z_axid
       IF (ziv > 0) THEN
-        str30 = zax_name(pfileid,ziv)
+        str30 = W_F(idf)%zax_name(ziv)
         assoc = TRIM(str30)//' '//TRIM(assoc)
       ENDIF
 !-
       IF (itax > 0) THEN
-        IF (nb_tax(pfileid) > 1) THEN
-          str30 = "t_"//tax_name(pfileid,itax)
+        IF (itax > 1) THEN
+          str30 = W_F(idf)%W_V(itax)%tax_name
         ELSE
           str30 = "time_counter"
@@ -1665,13 +1576,13 @@
         IF (l_dbg) THEN
           WRITE(*,*) "histend : 2.0.n, freq_opp, freq_wrt", &
- &                   freq_opp(pfileid,iv),freq_wrt(pfileid,iv)
+ &          W_F(idf)%W_V(iv)%freq_opp,W_F(idf)%W_V(iv)%freq_wrt
         ENDIF
 !-
-        iret = NF90_PUT_ATT (ncid,ncvarid,'interval_operation', &
- &                           REAL(freq_opp(pfileid,iv),KIND=4))
-        iret = NF90_PUT_ATT (ncid,ncvarid,'interval_write', &
- &                           REAL(freq_wrt(pfileid,iv),KIND=4))
+        iret = NF90_PUT_ATT (nfid,nvid,'interval_operation', &
+ &                           REAL(W_F(idf)%W_V(iv)%freq_opp,KIND=4))
+        iret = NF90_PUT_ATT (nfid,nvid,'interval_write', &
+ &                           REAL(W_F(idf)%W_V(iv)%freq_wrt,KIND=4))
       ENDIF
-      iret = NF90_PUT_ATT (ncid,ncvarid,'coordinates',TRIM(assoc))
+      iret = NF90_PUT_ATT (nfid,nvid,'coordinates',TRIM(assoc))
     ENDIF
   ENDDO
@@ -1679,6 +1590,6 @@
 ! 2.2 Add DOMAIN attributes if needed
 !-
-  IF (dom_id_svg(pfileid) >= 0) THEN
-    CALL flio_dom_att (ncid,dom_id_svg(pfileid))
+  IF (W_F(idf)%dom_id_svg >= 0) THEN
+    CALL flio_dom_att (nfid,W_F(idf)%dom_id_svg)
   ENDIF
 !-
@@ -1687,5 +1598,5 @@
   IF (l_dbg) WRITE(*,*) "histend : 3.0"
 !-
-  iret = NF90_ENDDEF (ncid)
+  iret = NF90_ENDDEF (nfid)
 !-
 ! 4.0 Give some informations to the user
@@ -1693,54 +1604,54 @@
   IF (l_dbg) WRITE(*,*) "histend : 4.0"
 !-
-  WRITE(str70,'("All variables have been initialized on file :",I3)') pfileid
+  WRITE(str70,'("All variables have been initialized on file :",I3)') idf
   CALL ipslerr (1,'histend',str70,'',' ')
 !---------------------
 END SUBROUTINE histend
 !===
-SUBROUTINE histwrite_r1d (pfileid,pvarname,pitau,pdata,nbindex,nindex)
+SUBROUTINE histwrite_r1d (idf,pvarname,pitau,pdata,nbindex,nindex)
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pitau,nbindex
+  INTEGER,INTENT(IN) :: idf,pitau,nbindex
   INTEGER,DIMENSION(nbindex),INTENT(IN) :: nindex
   REAL,DIMENSION(:),INTENT(IN) :: pdata
   CHARACTER(LEN=*),INTENT(IN) :: pvarname
 !---------------------------------------------------------------------
-  CALL histw_rnd (pfileid,pvarname,pitau,nbindex,nindex,pdata_1d=pdata)
+  CALL histw_rnd (idf,pvarname,pitau,nbindex,nindex,pdata_1d=pdata)
 !---------------------------
 END SUBROUTINE histwrite_r1d
 !===
-SUBROUTINE histwrite_r2d (pfileid,pvarname,pitau,pdata,nbindex,nindex)
+SUBROUTINE histwrite_r2d (idf,pvarname,pitau,pdata,nbindex,nindex)
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pitau,nbindex
+  INTEGER,INTENT(IN) :: idf,pitau,nbindex
   INTEGER,DIMENSION(nbindex),INTENT(IN) :: nindex
   REAL,DIMENSION(:,:),INTENT(IN) :: pdata
   CHARACTER(LEN=*),INTENT(IN) :: pvarname
 !---------------------------------------------------------------------
-  CALL histw_rnd (pfileid,pvarname,pitau,nbindex,nindex,pdata_2d=pdata)
+  CALL histw_rnd (idf,pvarname,pitau,nbindex,nindex,pdata_2d=pdata)
 !---------------------------
 END SUBROUTINE histwrite_r2d
 !===
-SUBROUTINE histwrite_r3d (pfileid,pvarname,pitau,pdata,nbindex,nindex)
+SUBROUTINE histwrite_r3d (idf,pvarname,pitau,pdata,nbindex,nindex)
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pitau,nbindex
+  INTEGER,INTENT(IN) :: idf,pitau,nbindex
   INTEGER,DIMENSION(nbindex),INTENT(IN) :: nindex
   REAL,DIMENSION(:,:,:),INTENT(IN) :: pdata
   CHARACTER(LEN=*),INTENT(IN) :: pvarname
 !---------------------------------------------------------------------
-  CALL histw_rnd (pfileid,pvarname,pitau,nbindex,nindex,pdata_3d=pdata)
+  CALL histw_rnd (idf,pvarname,pitau,nbindex,nindex,pdata_3d=pdata)
 !---------------------------
 END SUBROUTINE histwrite_r3d
 !===
-SUBROUTINE histw_rnd (pfileid,pvarname,pitau,nbindex,nindex, &
+SUBROUTINE histw_rnd (idf,pvarname,pitau,nbindex,nindex, &
   &                   pdata_1d,pdata_2d,pdata_3d)
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pitau,nbindex
+  INTEGER,INTENT(IN) :: idf,pitau,nbindex
   INTEGER,DIMENSION(nbindex),INTENT(IN) :: nindex
   CHARACTER(LEN=*),INTENT(IN) :: pvarname
@@ -1750,10 +1661,9 @@
 !-
   LOGICAL :: do_oper,do_write,largebuf,l1d,l2d,l3d
-  INTEGER :: varid,io,nbpt_out
+  INTEGER :: iv,io,nbpt_out
   INTEGER              :: nbpt_in1
   INTEGER,DIMENSION(2) :: nbpt_in2
   INTEGER,DIMENSION(3) :: nbpt_in3
-  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: buff_tmp
-  INTEGER,SAVE :: buff_tmp_sz
+  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: tbf_1
   CHARACTER(LEN=7) :: tmp_opp
   CHARACTER(LEN=13) :: c_nam
@@ -1771,8 +1681,12 @@
   ENDIF
 !-
+  IF (l_dbg) THEN
+    WRITE(*,*) "histwrite : ",c_nam
+  ENDIF
+!-
 ! 1.0 Try to catch errors like specifying the wrong file ID.
 !     Thanks Marine for showing us what errors users can make !
 !-
-  IF ( (pfileid < 1).OR.(pfileid > nb_files) ) THEN
+  IF ( (idf < 1).OR.(idf > nb_files_max) ) THEN
     CALL ipslerr (3,"histwrite", &
  &    'Illegal file ID in the histwrite of variable',pvarname,' ')
@@ -1781,18 +1695,18 @@
 ! 1.1 Find the id of the variable to be written and the real time
 !-
-  CALL histvar_seq (pfileid,pvarname,varid)
+  CALL histvar_seq (idf,pvarname,iv)
 !-
 ! 2.0 do nothing for never operation
 !-
-  tmp_opp = topp(pfileid,varid)
+  tmp_opp = W_F(idf)%W_V(iv)%topp
 !-
   IF (TRIM(tmp_opp) == "never") THEN
-    last_opp_chk(pfileid,varid) = -99
-    last_wrt_chk(pfileid,varid) = -99
+    W_F(idf)%W_V(iv)%last_opp_chk = -99
+    W_F(idf)%W_V(iv)%last_wrt_chk = -99
   ENDIF
 !-
 ! 3.0 We check if we need to do an operation
 !-
-  IF (last_opp_chk(pfileid,varid) == pitau) THEN
+  IF (W_F(idf)%W_V(iv)%last_opp_chk == pitau) THEN
     CALL ipslerr (3,"histwrite", &
  &    'This variable has already been analysed at the present', &
@@ -1801,18 +1715,22 @@
 !-
   CALL isittime &
- &  (pitau,date0(pfileid),deltat(pfileid),freq_opp(pfileid,varid), &
- &   last_opp(pfileid,varid),last_opp_chk(pfileid,varid),do_oper)
+ &  (pitau,W_F(idf)%date0,W_F(idf)%deltat, &
+ &   W_F(idf)%W_V(iv)%freq_opp, &
+ &   W_F(idf)%W_V(iv)%last_opp, &
+ &   W_F(idf)%W_V(iv)%last_opp_chk,do_oper)
 !-
 ! 4.0 We check if we need to write the data
 !-
-  IF (last_wrt_chk(pfileid,varid) == pitau) THEN
+  IF (W_F(idf)%W_V(iv)%last_wrt_chk == pitau) THEN
     CALL ipslerr (3,"histwrite", &
- &    'This variable has already been written for the present', &
- &    'time step',TRIM(pvarname))
+ &    'This variable as already been written for the present', &
+ &    'time step',' ')
   ENDIF
 !-
   CALL isittime &
- &  (pitau,date0(pfileid),deltat(pfileid),freq_wrt(pfileid,varid), &
- &   last_wrt(pfileid,varid),last_wrt_chk(pfileid,varid),do_write)
+ &  (pitau,W_F(idf)%date0,W_F(idf)%deltat, &
+ &   W_F(idf)%W_V(iv)%freq_wrt, &
+ &   W_F(idf)%W_V(iv)%last_wrt, &
+ &   W_F(idf)%W_V(iv)%last_wrt_chk,do_write)
 !-
 ! 5.0 histwrite called
@@ -1822,19 +1740,19 @@
 !-- 5.1 Get the sizes of the data we will handle
 !-
-    IF (datasz_in(pfileid,varid,1) <= 0) THEN
+    IF (W_F(idf)%W_V(iv)%datasz_in(1) <= 0) THEN
 !---- There is the risk here that the user has over-sized the array.
 !---- But how can we catch this ?
 !---- In the worst case we will do impossible operations
 !---- on part of the data !
-      datasz_in(pfileid,varid,1:3) = -1
+      W_F(idf)%W_V(iv)%datasz_in(1:3) = -1
       IF      (l1d) THEN
-        datasz_in(pfileid,varid,1) = SIZE(pdata_1d)
+        W_F(idf)%W_V(iv)%datasz_in(1) = SIZE(pdata_1d)
       ELSE IF (l2d) THEN
-        datasz_in(pfileid,varid,1) = SIZE(pdata_2d,DIM=1)
-        datasz_in(pfileid,varid,2) = SIZE(pdata_2d,DIM=2)
+        W_F(idf)%W_V(iv)%datasz_in(1) = SIZE(pdata_2d,DIM=1)
+        W_F(idf)%W_V(iv)%datasz_in(2) = SIZE(pdata_2d,DIM=2)
       ELSE IF (l3d) THEN
-        datasz_in(pfileid,varid,1) = SIZE(pdata_3d,DIM=1)
-        datasz_in(pfileid,varid,2) = SIZE(pdata_3d,DIM=2)
-        datasz_in(pfileid,varid,3) = SIZE(pdata_3d,DIM=3)
+        W_F(idf)%W_V(iv)%datasz_in(1) = SIZE(pdata_3d,DIM=1)
+        W_F(idf)%W_V(iv)%datasz_in(2) = SIZE(pdata_3d,DIM=2)
+        W_F(idf)%W_V(iv)%datasz_in(3) = SIZE(pdata_3d,DIM=3)
       ENDIF
     ENDIF
@@ -1842,50 +1760,48 @@
 !-- 5.2 The maximum size of the data will give the size of the buffer
 !-
-    IF (datasz_max(pfileid,varid) <= 0) THEN
+    IF (W_F(idf)%W_V(iv)%datasz_max <= 0) THEN
       largebuf = .FALSE.
-      DO io=1,nbopp(pfileid,varid)
-        IF (INDEX(fuchnbout,sopps(pfileid,varid,io)) > 0) THEN
+      DO io=1,W_F(idf)%W_V(iv)%nbopp
+        IF (INDEX(fuchnbout,W_F(idf)%W_V(iv)%sopp(io)) > 0) THEN
           largebuf = .TRUE.
         ENDIF
       ENDDO
       IF (largebuf) THEN
-        datasz_max(pfileid,varid) = &
- &        scsize(pfileid,varid,1) &
- &       *scsize(pfileid,varid,2) &
- &       *scsize(pfileid,varid,3)
+        W_F(idf)%W_V(iv)%datasz_max = &
+ &        W_F(idf)%W_V(iv)%scsize(1) &
+ &       *W_F(idf)%W_V(iv)%scsize(2) &
+ &       *W_F(idf)%W_V(iv)%scsize(3)
       ELSE
         IF      (l1d) THEN
-          datasz_max(pfileid,varid) = &
- &          datasz_in(pfileid,varid,1)
+          W_F(idf)%W_V(iv)%datasz_max = &
+ &          W_F(idf)%W_V(iv)%datasz_in(1)
         ELSE IF (l2d) THEN
-          datasz_max(pfileid,varid) = &
- &          datasz_in(pfileid,varid,1) &
- &         *datasz_in(pfileid,varid,2)
+          W_F(idf)%W_V(iv)%datasz_max = &
+ &          W_F(idf)%W_V(iv)%datasz_in(1) &
+ &         *W_F(idf)%W_V(iv)%datasz_in(2)
         ELSE IF (l3d) THEN
-          datasz_max(pfileid,varid) = &
- &          datasz_in(pfileid,varid,1) &
- &         *datasz_in(pfileid,varid,2) &
- &         *datasz_in(pfileid,varid,3)
+          W_F(idf)%W_V(iv)%datasz_max = &
+ &          W_F(idf)%W_V(iv)%datasz_in(1) &
+ &         *W_F(idf)%W_V(iv)%datasz_in(2) &
+ &         *W_F(idf)%W_V(iv)%datasz_in(3)
         ENDIF
       ENDIF
     ENDIF
 !-
-    IF (.NOT.ALLOCATED(buff_tmp)) THEN
+    IF (.NOT.ALLOCATED(tbf_1)) THEN
       IF (l_dbg) THEN
         WRITE(*,*) &
- &       c_nam//" : allocate buff_tmp for buff_sz = ", &
- &       datasz_max(pfileid,varid)
+ &       c_nam//" : allocate tbf_1 for size = ", &
+ &       W_F(idf)%W_V(iv)%datasz_max
       ENDIF
-      ALLOCATE(buff_tmp(datasz_max(pfileid,varid)))
-      buff_tmp_sz = datasz_max(pfileid,varid)
-    ELSE IF (datasz_max(pfileid,varid) > buff_tmp_sz) THEN
+      ALLOCATE(tbf_1(W_F(idf)%W_V(iv)%datasz_max))
+    ELSE IF (W_F(idf)%W_V(iv)%datasz_max > SIZE(tbf_1)) THEN
       IF (l_dbg) THEN
         WRITE(*,*) &
- &       c_nam//" : re-allocate buff_tmp for buff_sz = ", &
- &       datasz_max(pfileid,varid)
+ &       c_nam//" : re-allocate tbf_1 for size = ", &
+ &       W_F(idf)%W_V(iv)%datasz_max
       ENDIF
-      DEALLOCATE(buff_tmp)
-      ALLOCATE(buff_tmp(datasz_max(pfileid,varid)))
-      buff_tmp_sz = datasz_max(pfileid,varid)
+      DEALLOCATE(tbf_1)
+      ALLOCATE(tbf_1(W_F(idf)%W_V(iv)%datasz_max))
     ENDIF
 !-
@@ -1894,23 +1810,23 @@
 !-- of the data at the same time. This should speed up things.
 !-
-    nbpt_out = datasz_max(pfileid,varid)
+    nbpt_out = W_F(idf)%W_V(iv)%datasz_max
     IF      (l1d) THEN
-      nbpt_in1 = datasz_in(pfileid,varid,1)
-      CALL mathop (sopps(pfileid,varid,1),nbpt_in1,pdata_1d, &
+      nbpt_in1 = W_F(idf)%W_V(iv)%datasz_in(1)
+      CALL mathop (W_F(idf)%W_V(iv)%sopp(1),nbpt_in1,pdata_1d, &
  &                 missing_val,nbindex,nindex, &
- &                 scal(pfileid,varid,1),nbpt_out,buff_tmp)
+ &                 W_F(idf)%W_V(iv)%scal(1),nbpt_out,tbf_1)
     ELSE IF (l2d) THEN
-      nbpt_in2(1:2) = datasz_in(pfileid,varid,1:2)
-      CALL mathop (sopps(pfileid,varid,1),nbpt_in2,pdata_2d, &
+      nbpt_in2(1:2) = W_F(idf)%W_V(iv)%datasz_in(1:2)
+      CALL mathop (W_F(idf)%W_V(iv)%sopp(1),nbpt_in2,pdata_2d, &
  &                 missing_val,nbindex,nindex, &
- &                 scal(pfileid,varid,1),nbpt_out,buff_tmp)
+ &                 W_F(idf)%W_V(iv)%scal(1),nbpt_out,tbf_1)
     ELSE IF (l3d) THEN
-      nbpt_in3(1:3) = datasz_in(pfileid,varid,1:3)
-      CALL mathop (sopps(pfileid,varid,1),nbpt_in3,pdata_3d, &
+      nbpt_in3(1:3) = W_F(idf)%W_V(iv)%datasz_in(1:3)
+      CALL mathop (W_F(idf)%W_V(iv)%sopp(1),nbpt_in3,pdata_3d, &
  &                 missing_val,nbindex,nindex, &
- &                 scal(pfileid,varid,1),nbpt_out,buff_tmp)
-    ENDIF
-    CALL histwrite_real (pfileid,varid,pitau,nbpt_out, &
- &            buff_tmp,nbindex,nindex,do_oper,do_write)
+ &                 W_F(idf)%W_V(iv)%scal(1),nbpt_out,tbf_1)
+    ENDIF
+    CALL histwrite_real (idf,iv,pitau,nbpt_out, &
+ &            tbf_1,nbindex,nindex,do_oper,do_write)
   ENDIF
 !-
